# 仮想シリアルポートと、実シリアルポートを列挙する
# pythonnet使用バージョン

import clr
import System.IO.Ports
import serial
from serial.tools import list_ports # 実ポートのみ取得


# 各リアルデバイスの検索/詳細表示と, そのデバイス名を抽出してリスト化
def real_port_search() -> str:

    device_list = []

    # 実デバイスの列挙
    all_real_device_list = list_ports.comports()

    print('\n ------ Real  port ------')

    # 各実デバイスの詳細表示と, そのデバイス名を抽出してリスト化
    for real_device in all_real_device_list:


        # 各実デバイスの詳細表示
        print(" device      :", real_device.device)
        print(" description :", real_device.description.replace(' ', ''))
        try:
            print(" vid         :", hex(real_device.vid))
            print(" pid         :", hex(real_device.pid))
        except:
            pass

        print()

        # 各実デバイス名を抽出してリスト化
        device_list.append(real_device.device)

    return device_list

# 全デバイスの検索とリスト化
def all_port_search() -> list:

    all_device_list = []

    ports = System.IO.Ports.SerialPort.GetPortNames()

    for port in ports:

        all_device_list.append(port)

    return all_device_list

real_port = real_port_search() # 各実デバイス名のリストを表示
all_port = all_port_search()   # 全デバイス名のリストを表示

for i in real_port:

    for j in all_port:

        if j == i:
            all_port.remove(j)

print(' ----- Virtual port -----\n', all_port)

input('\n Enterで終了>')
